"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const typescript_1 = __importDefault(require("typescript"));
/**
 * export class Client<ApiClient> {
 *   {members}
 * }
 */
const create = (factory, members) => {
    return factory.ClassDeclaration.create({
        name: "Client",
        export: true,
        members: [
            factory.PropertyDeclaration.create({
                modifiers: [typescript_1.default.factory.createModifier(typescript_1.default.SyntaxKind.PrivateKeyword)],
                name: "baseUrl",
                type: typescript_1.default.factory.createKeywordTypeNode(typescript_1.default.SyntaxKind.StringKeyword),
            }),
            ...members,
        ],
        typeParameterDeclaration: [
            factory.TypeParameterDeclaration.create({
                name: "RequestOption",
            }),
        ],
    });
};
exports.create = create;
//# sourceMappingURL=Class.js.map