"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.generateUrlTemplateExpression = exports.isPathParameter = void 0;
const Utils = __importStar(require("../../utils"));
const utils_1 = require("../../../../utils");
const isPathParameter = (params) => {
    return params.in === "path";
};
exports.isPathParameter = isPathParameter;
/**
 * const url = this.baseUrl + `[head]${params.parameter.[parameterName]}`;
 */
const generateUrlVariableStatement = (factory, urlTemplate) => {
    return factory.VariableStatement.create({
        declarationList: factory.VariableDeclarationList.create({
            declarations: [
                factory.VariableDeclaration.create({
                    name: "url",
                    initializer: factory.BinaryExpression.create({
                        left: factory.PropertyAccessExpression.create({
                            name: "baseUrl",
                            expression: "this",
                        }),
                        operator: "+",
                        right: Utils.generateTemplateExpression(factory, urlTemplate),
                    }),
                }),
            ],
            flag: "const",
        }),
    });
};
const generateUrlTemplateExpression = (factory, requestUri, pathParameters) => {
    const patternMap = pathParameters.reduce((previous, item) => {
        return { ...previous, [`{${item.name}}`]: item.name };
    }, {});
    const urlTemplate = [];
    let temporaryStringList = [];
    // TODO generateVariableIdentifierに噛み合わ下げいいように変換する
    const replaceText = (text) => {
        let replacedText = text;
        Object.keys(patternMap).forEach(pathParameterName => {
            if (new RegExp(pathParameterName).test(replacedText)) {
                const { text, escaped } = utils_1.escapeText2(patternMap[pathParameterName]);
                const variableDeclaraText = escaped ? `params.parameter[${text}]` : `params.parameter.${text}`;
                replacedText = replacedText.replace(new RegExp(pathParameterName, "g"), variableDeclaraText);
            }
        });
        return replacedText === text ? undefined : replacedText;
    };
    const requestUrlTicks = Utils.multiSplitStringToArray(requestUri, Object.keys(patternMap));
    requestUrlTicks.forEach((requestUriTick, index) => {
        if (requestUri === "") {
            temporaryStringList.push("");
            return;
        }
        const replacedText = replaceText(requestUriTick);
        if (replacedText) {
            if (temporaryStringList.length > 0) {
                const value = temporaryStringList.join("/");
                urlTemplate.push({
                    type: "string",
                    value: value,
                });
                temporaryStringList = [];
            }
            urlTemplate.push({
                type: "property",
                value: Utils.generateVariableIdentifier(factory, replacedText),
            });
        }
        else {
            temporaryStringList.push(requestUriTick);
        }
        if (index === requestUrlTicks.length - 1) {
            const value = temporaryStringList.join("/");
            if (value === "") {
                urlTemplate.push({
                    type: "string",
                    value: requestUri.endsWith("/") ? "/" : "",
                });
            }
            else {
                urlTemplate.push({
                    type: "string",
                    value: value.startsWith("/") ? value : "/" + value,
                });
            }
        }
    });
    return urlTemplate;
};
exports.generateUrlTemplateExpression = generateUrlTemplateExpression;
const create = (factory, requestUri, pathParameters) => {
    if (pathParameters.length > 0) {
        const urlTemplate = exports.generateUrlTemplateExpression(factory, requestUri, pathParameters);
        return generateUrlVariableStatement(factory, urlTemplate);
    }
    return generateUrlVariableStatement(factory, [{ type: "string", value: requestUri }]);
};
exports.create = create;
//# sourceMappingURL=PathParameter.js.map